unit DataModuleUnit;

interface

uses
  SysUtils, Classes, kdclxcore, kdinterrupt;

type
  TCustomCardDataModule = class(TDataModule)
    kdCustomCard1: TkdCustomCard;
    kdInterrupt3: TkdInterrupt;
    kdInterrupt4: TkdInterrupt;
    kdInterrupt5: TkdInterrupt;
    kdInterrupt6: TkdInterrupt;
    kdInterrupt7: TkdInterrupt;
    kdInterrupt8: TkdInterrupt;
    kdInterrupt9: TkdInterrupt;
    kdInterrupt10: TkdInterrupt;
    kdInterrupt11: TkdInterrupt;
    kdInterrupt12: TkdInterrupt;
    kdInterrupt13: TkdInterrupt;
    kdInterrupt14: TkdInterrupt;
    kdInterrupt15: TkdInterrupt;
    procedure kdInterruptHwInterrupt(Sender: TkdInterrupt);
  private
    { Private declarations }
  protected
    procedure FillInterruptsStatistics (Sender: TkdInterrupt);
  public
    { Public declarations }
  end;

var
  CustomCardDataModule: TCustomCardDataModule;

implementation
uses Unit1;
{ Unit1: access to InterruptsGenerated, InterruptsHandled,
  InterruptsPreviousTimes, InterruptsLatestTimes variables }


{$R *.xfm}

procedure TCustomCardDataModule.FillInterruptsStatistics(Sender: TkdInterrupt);
begin
  InterruptsGenerated[Sender.InterruptNumber]:= Sender.InterruptsGenerated;
  InterruptsHandled[Sender.InterruptNumber]:= Sender.InterruptsDirected;
  InterruptsPreviousTimes[Sender.InterruptNumber]:= Sender.InterruptPreviousTime;
  InterruptsLatestTimes[Sender.InterruptNumber]:= Sender.InterruptLastTime;
end;

procedure TCustomCardDataModule.kdInterruptHwInterrupt(Sender: TkdInterrupt);
begin
  // A complete code of handling hardware interrupts in the user space.
  // This is for demonstration purpose only in order to show interrupts coming to the user application.
  FillInterruptsStatistics (Sender);
end;

end.
