unit Unit1;

interface

uses
  SysUtils, Types, Classes, Variants, QGraphics, QControls, QForms, QDialogs, 
  kdinterrupt, kdregister, kdclxcore, kdranges, QStdCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label4: TLabel;
    Step1Button: TButton;
    Label5: TLabel;
    Step2Button: TButton;
    Step3Button: TButton;
    Label3: TLabel;
    procedure Step1ButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Step2ButtonClick(Sender: TObject);
    procedure Step3ButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
uses
  DataModuleUnit;

{$R *.xfm}

procedure TForm1.Step1ButtonClick(Sender: TObject);
begin
  CustomCardDataModule.control.Value:= CustomCardDataModule.control.Value or $10;
  Step1Button.Caption:= 'Done'
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  CustomCardDataModule.kdCustomCard1.ModuleLoaded:= True;
  if not CustomCardDataModule.kdCustomCard1.ModuleLoaded then
  begin
    MessageDlg('The GDD is not loaded!', mtInformation, [mbOK], 0, mbOK);
    halt;
  end;
  CustomCardDataModule.kdCustomCard1.RegisterCard;
  if not CustomCardDataModule.kdCustomCard1.CardRegistered then
  begin
    MessageDlg('Unable to register the card!', mtInformation, [mbOK], 0, mbOK);
    halt;
  end;  
end;

procedure TForm1.Step2ButtonClick(Sender: TObject);
begin
  with CustomCardDataModule.kdInterrupt1 do 
  begin
    InterruptRTSynchronized:= True;  // safe-working "ShowMessage" procedure
    EnableInterrupt; 
  end;
  Step2Button.Caption:= 'Done'  
end;

procedure TForm1.Step3ButtonClick(Sender: TObject);
begin
  with CustomCardDataModule.data do 
  begin
    Value:= $00;
    Value:= $ff;
  end
end;

end.
